/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Software
 *
 *  Copyright (C) 2012-2015 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: gpos_app.c 724 2015-03-11 09:57:33Z ertl-honda $
 */

#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <unistd.h>
#include "doscom.h"

bool
filter_even(void *buffer, uint32_t size)
{
	uint32_t value;

	value = *((uint32_t *)buffer);

	if ((value % 2) == 0)  return true;
	return false;
}

#define SMEMCH_SMEM_SIZE 64

void
smemch_test() {
	int ret;
	void *p_smem;
	int i;

	printf("SMEM CHANNEL test start!.\n");
	fflush(stdout);

	ret = doscom_smemch_get(DOSCOM_SMEMCH_1, &p_smem);
	if(ret != 0) {
		printf("Get Buffer Error!! %d\n",ret);
		fflush(stdout);
	}

	printf("smem 0x%x.\n", (unsigned int)p_smem);
	fflush(stdout);

	while(1) {
		for(i = 0; i < SMEMCH_SMEM_SIZE/8; i++){
			printf("%d : %d, ", i, *((uint32_t *)p_smem + i));
		}
		printf("\n");
		sleep(2);
	}
}

int
main()
{
	int ret;
	void *p_block;
	doscom_id_t block_id;
	char msg[] = "hey!";

	printf("GPOS doscom_init\n");
	ret = doscom_init(0x03, 0);
	assert(ret == 0);

	printf("Dual-OS communications initialized\n");

	printf("GPOS send start ack\n");
	ret = doscom_fifoch_notify(DOSCOM_FIFOCH_0);
	assert(ret == 0);

	/* phase 1 */
	printf("GPOS wait for message\n");
	ret = doscom_fifoch_wait(DOSCOM_FIFOCH_0, 0);
	assert(ret == 0);

	printf("Event received\n");

	ret = doscom_fifoch_dequeue(DOSCOM_FIFOCH_0, &block_id);
	printf("doscom_fifoch_dequeue() %d\n", ret);
	assert(ret == 0);

	ret = doscom_fifoch_get(DOSCOM_FIFOCH_0, block_id, &p_block);
	assert(ret == 0);

	printf("MSG: %s\n", (char *)p_block);

	printf("GPOS send ack\n");
	ret = doscom_fifoch_notify(DOSCOM_FIFOCH_0);
	assert(ret == 0);

	/* phase 2 */
	printf("GPOS wait for rpc\n");
	ret = doscom_fifoch_wait(DOSCOM_FIFOCH_0, 0);
	assert(ret == 0);

	printf("received params: %u and %u\n",
		   *((uint32_t *)p_block), *((uint32_t *)(p_block + 4)));

	*((uint32_t *)p_block) = *((uint32_t *)p_block) * *((uint32_t *)(p_block + 4));
	printf("GPOS send rpc result (%u)\n", *((uint32_t *)p_block));

	ret = doscom_fifoch_notify(DOSCOM_FIFOCH_0);
	assert(ret == 0);


	/* phase 3 */
	printf("GPOS wait for rpc\n");
	ret = doscom_fifoch_wait(DOSCOM_FIFOCH_0, 0);
	assert(ret == 0);

	printf("received params: %u and %u\n",
		   *((uint32_t *)p_block), *((uint32_t *)(p_block + 4)));

	*((uint32_t *)p_block) = *((uint32_t *)p_block) * *((uint32_t *)(p_block + 4));
	printf("GPOS send rpc result (%u)\n", *((uint32_t *)p_block));

	ret = doscom_fifoch_notify(DOSCOM_FIFOCH_0);
	assert(ret == 0);

	ret = doscom_fifoch_wait(DOSCOM_FIFOCH_0, 0);
	assert(ret == 0);

	/* phase 4 */
	printf("Send a message to the RTOS by fifoch 1\n");
	ret = doscom_fifoch_alloc(DOSCOM_FIFOCH_1, &block_id);
	assert(ret == 0);

	ret = doscom_fifoch_get(DOSCOM_FIFOCH_1, block_id, &p_block);
	assert(ret == 0);

	memcpy(p_block, (void *)msg, sizeof(msg));

	ret = doscom_fifoch_enqueue(DOSCOM_FIFOCH_1, block_id);
	assert(ret == 0);

	ret = doscom_fifoch_notify(DOSCOM_FIFOCH_1);
	assert(ret == 0);

	ret = doscom_fifoch_wait(DOSCOM_FIFOCH_0, 0);
	assert(ret == 0);

	/* phase 5 */
	printf("Send several messages with a filter on\n");

	ret = doscom_fifoch_alloc(DOSCOM_FIFOCH_0, &block_id);
	assert(ret == 0);

	ret = doscom_fifoch_get(DOSCOM_FIFOCH_0, block_id, &p_block);
	assert(ret == 0);

	*((uint32_t *)p_block) = 1;
	printf("call doscom_fifoch_enqueue\n");
	ret = doscom_fifoch_enqueue(DOSCOM_FIFOCH_0, block_id);
	if(ret != 0) printf("data %u filtered\n",*((uint32_t *)p_block));

	ret = doscom_fifoch_alloc(DOSCOM_FIFOCH_0, &block_id);
	assert(ret == 0);

	ret = doscom_fifoch_get(DOSCOM_FIFOCH_0, block_id, &p_block);
	assert(ret == 0);

	*((uint32_t *)p_block) = 2;

	ret = doscom_fifoch_enqueue(DOSCOM_FIFOCH_0, block_id);
	if(ret != 0) printf("data %u filtered\n",*((uint32_t *)p_block));

	ret = doscom_fifoch_alloc(DOSCOM_FIFOCH_0, &block_id);
	assert(ret == 0);

	ret = doscom_fifoch_get(DOSCOM_FIFOCH_0, block_id, &p_block);
	assert(ret == 0);

	*((uint32_t *)p_block) = 3;

	ret = doscom_fifoch_enqueue(DOSCOM_FIFOCH_0, block_id);
	if(ret != 0) printf("data %u filtered\n",*((uint32_t *)p_block));

	ret = doscom_fifoch_notify(DOSCOM_FIFOCH_0);
	assert(ret == 0);

	smemch_test();

	return 0;
}
