/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Software
 * 
 *  Copyright (C) 2012-2013 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: gpos_app.c 592 2013-11-17 16:01:02Z ertl-honda $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <unistd.h>
#include "doscom.h"
#include "syscalls_api.h"

bool
filter_even(void *buffer, uint32_t size)
{
	uint32_t value;

	value = *((uint32_t *)buffer);

	if ((value % 2) == 0)  return true;
	return false;
}

int main(int argc, char *argv[])
{
	int ret;
	void *buffer;
	doscom_id_t block_id;
	int channel_mask = atoi(argv[1]);
	int channel_id = 0;
	int rec_flag = atoi(argv[2]);
	//FILE *fp = fopen("result.txt", "w");

	printf("This is com_fifo_reconnect.exe %d %d\n", atoi(argv[1]), atoi(argv[2]));
	//fprintf(fp, "This is com_fifo_reconnect.exe\n");
	ret = doscom_init(channel_mask, 0);

	if (ret == DOSCOM_ECTX) {
		printf("DOSCOM_INIT ret = DOSCOM_ECTX error\n");
		//fprintf(fp, "DOSCOM_INIT ret = DOSCOM_ECTX error\n");
		assert(ret == 0);
		return 0;
	}	
	else if (ret == DOSCOM_EASSIGN) {
		printf("DOSCOM_INIT ret = DOSCOM_EASSIGN error\n");
		//fprintf(fp, "DOSCOM_INIT ret = DOSCOM_EASSIGN error\n");
		assert(ret == 0);
		return 0;
	}
	else if (ret != DOSCOM_SUCCESS) {
		printf("DOSCOM_INIT error\n");
		//fprintf(fp, "DOSCOM_INIT error\n");
		assert(ret == 0);
		return 0;
	}
	printf("Dual-OS communications initialized\n");
	//fprintf(fp, "Dual-OS communications initialized\n");

	/* If argv[1] == '0' then return */
	if (!rec_flag){
		printf("argv[2] = '0'. Exit connection.\n");
		//fprintf(fp, "argv[3] = '0'. Exit connection.\n");
		return 0;
	}

	while(channel_mask){
		if (channel_mask & 0x1){
			/* message test */
			ret = doscom_fifoch_dequeue(channel_id, &block_id);
			//printf("doscom_block_dequeue() %d\n", ret);
			assert(ret == 0);

			ret = doscom_fifoch_get(channel_id, block_id, &buffer);
			assert(ret == 0);

			/* Verify Message */
			printf("rec_data = %s\n", (char *)buffer);
			if (strcmp((char *)buffer, "onetime")){
				printf("Invalid data received. rec_data = %s\n", (char *)buffer);
				while(1){}
			}
		}
		channel_mask = channel_mask >> 1;
		channel_id++;
	}
	return 0;
}
